/*
 * Asynchronous Engine .
 *
 * Copyright (C) 2004 Claude Hussenet
 * Contact : chussenet@yahoo.com
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package test.patterns.readwritelock;
import junit.framework.TestCase;

/**
 *
 * @version <tt>$Revision: 1.1.4.3 $</tt>
 * @author  <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 */
public class JUnitTestReadWriteLockAspects
	extends TestCase
	  {
	public JUnitTestReadWriteLockAspects(String arg0) {
		super(arg0);

	}

	public static void testProcessReadWriteLockPattern()
	{

	Account accountWithoutReadWriteLock = new Account(1000);
	processReadWriteLockPattern(accountWithoutReadWriteLock);

    assertTrue("No Concurrent Issue without ReadWriteLock Aspect !",1000!=accountWithoutReadWriteLock.getBalance());
  	Account accountWithReadWriteLock = new AccountWithReadWriteLock(1000);
	processReadWriteLockPattern(accountWithReadWriteLock);
    assertTrue("Concurrent Issue with ReadWriteLock Aspect !",1000==accountWithReadWriteLock.getBalance());

	}

	   public static void processReadWriteLockPattern(Account account)
	   {

	     new Thread(new ProcessTransaction(account,100)).start();
	     new Thread(new ProcessTransaction(account,300)).start();
	     new Thread(new ProcessTransaction(account,-150)).start();
	     new Thread(new ProcessTransaction(account,-250)).start();

	     try
	     {
			 Thread.sleep(500);
	     }
	     catch (Exception e)
	     {
	       System.out.println(e);
		 }
	   }








}